

	' Contest Klopper
	' fr den BlitzForum.de Contest	
	' M2M
	
	SetMaskColor 255,255,255
	Global img_loch = LoadAnimImage("bilder/loch.png",47,22,0,2)
	Global img_tier = LoadAnimImage("bilder/tier.png",45,45,0,2)
	Global img_set0 = LoadImage("bilder/set0.png")
	Global img_set1 = LoadImage("bilder/set1.png")
	Global img_flare = LoadImage("bilder/flare.png")
	Global but_mute = LoadAnimImage("bilder/mute.png",40,40,0,2)
	Global but_ende = LoadAnimImage("bilder/ende.png",40,40,0,2)
	Global but_voll = LoadAnimImage("bilder/voll.png",40,40,0,2)
	Global img_pointer = LoadAnimImage("bilder/pointer.png",16,24,0,2)
	Global but_solve = LoadAnimImage("bilder/solve.png",118,128,0,2)
	Global but_neu = LoadAnimImage("bilder/neu.png",40,40,0,2)

	Global fnt_digit = LoadImageFont("foo.ttf",85)
	Global fnt_digit2 = LoadImageFont("foo.ttf",45)
	Global fnt_digit3 = LoadImageFont("foo.ttf",100)
	Global fnt_gaps = LoadImageFont("foo.ttf",14)
	
	Global snd_dreh = LoadSound("sound/dreh.wav")
	Global snd_pop = LoadSound("sound/pop.wav")
	Global snd_horn = LoadSound("sound/horn.wav")
	Global music_loop = LoadSound("sound/loop.wav",SOUND_LOOP)
	Global snd_right = LoadSound("sound/right.wav")
	Global snd_wrong = LoadSound("sound/wrong.wav")
	
	Global channel_loop = AllocChannel()
	PlaySound music_loop,channel_loop
	
	Global channel_effects = AllocChannel()

	Global timer = CreateTimer(60)
	Global sx:Float = 1,sy:Float,zahl:Int,j:Int 
	Global mh
	Global sound:Int = 1
	Global counter:Int = 4
	Global mpstate:Int = 0						' Mauszeiger Status
	Global gamestart:Int = 0,gameover:Int = 0,ffa:Float = 0,ffb:Int = 0
	Global p:Int = 0,punkte:Int = 0
	Global SOLV:Int = 2,r:Float = 0,rb:Float,way:Int = 0
	Global ergebnis:Int,such:String 
	
	Global secs:Int = MilliSecs()	' Sekundentimer
	
	Global VOLLBILD:Int = 1,HILFE:Int = 0	' 
	Global los:Int = 0
	
	Global FALSCH:Int,RICHTIG:Int,FALSCHZEIT:Int,ff:Float = 1
	
	Global DIFFICULTY = 60			' Schwierigkeit 
	HideMouse() 
	
	Type TTier
		Field id:Int,isid:Int,hit:Int,sync:Float,frame:Int,kommraus:Int,raus:Int,istraus:Int,zu:Int,show:Int,showi:Float,bleib:Int  
	End Type 
	Global TListTier:TList = CreateList()
	
	Type ANITEXT
		Field id,text$,x,y,split$[32],mov#[32],movdir[32],r,g,b,v
	End Type
	Global TListAniText:TList = CreateList()
	
	Type TPart
		Field x:Int,y:Int,a:Float
	End Type
	Global TListPart:TList = CreateList() 
		
	For i:Int = 0 To 7
		tier:TTier = New TTier
			tier.id = i
			tier.isid = i+1
			tier.hit = 0
		ListAddLast(TListTier,tier)
	Next 

	NEWANITEXT(1,110,450,"Willkommen bei ",132,181,73,1)
	NEWANITEXT(1,310,450,"Contest Klopper ",172,181,73,1)
	
	Graphics 640,480,24,60
	SeedRnd MilliSecs()
	AppTitle$ = "Contest Klopper"
	
	' ********************************************************	
	While Not KeyHit(key_escape)
		SetClsColor 154,207,241
		Cls 
		SetBlend ALPHABLEND
				
		SetChannelVolume channel_loop,sound
		SetChannelVolume channel_effects,sound 			
			
		DrawImage img_set0,0,0
		
		If ((MilliSecs()-curr)>=1000)
      		curr = MilliSecs() 
      		counter:-1
   		EndIf 
		
		mh = MouseHit(1)		
		ZeichneLochB()
		ZeichneTiere()
		DrawImage img_set1,0,271
		ZeichneLochA()
		Anzeige()
		Animate(0)
		Animate(1)

		DrawImage img_pointer,MouseX(),MouseY(),mpstate 
		mpstate = 0
				
		If KeyHit(key_s)
			SavePixmapPNG(GrabPixmap(0,0,640,480) ,"screenshot_"+CurrentDate()+"-"+CurrentTime()+".png")
		EndIf
		
		If KeyHit(key_p)
			WaitKey()			
		EndIf 
		
		WaitTimer timer
		Flip 1
		 
	Wend 
	' ******************************************************** 
	
	Function ZeichneLochA()
		For i:Int = 1 To 8
			DrawImage img_loch,53+i*70-70,260,1
		Next 
	End Function 
	
	Function ZeichneLochB()
		For i:Int = 1 To 8
			DrawImage img_loch,53+i*70-70,260,0
		Next 
	End Function 
	
	Function ZeichneTiere()
	
		For tier:TTier = EachIn TListTier
		If tier.bleib = 0
			If tier.hit = 0 And gamestart = 1 
			
			If tier.istraus = 0 
				If tier.zu <> 1
					tier.zu = Rand(1,DIFFICULTY)
				Else
					tier.kommraus = 1
				EndIf 
				If tier.kommraus = 1
					If tier.raus < 20
						tier.raus:+1
					Else 
						PlaySound snd_dreh,channel_effects
						tier.kommraus = 0
						tier.istraus = 1
						tier.zu = 0
					EndIf 
				EndIf 
				
			Else
				If tier.zu <> 1
					tier.zu = Rand(1,DIFFICULTY)
				Else
					tier.kommraus = 2
				EndIf
				If tier.kommraus = 2
					tier.istraus = 2
					If tier.raus > 0
						tier.raus:-1
					Else
						tier.kommraus = 0
						tier.zu = 0
						tier.istraus = 0
					EndIf
				EndIf 
			EndIf 
			EndIf 
		EndIf 
			tier.sync:+.1
				If tier.sync >= 2
					If tier.frame < 1
						tier.frame:+1
						tier.sync = 0
					Else
						tier.frame = 0
						tier.sync = Rand(-10)
					EndIf 
				EndIf 
				SetColor 255,255,255
				SetAlpha 1
				If MouseX() > 53+tier.id*70 And MouseX() < 53+tier.id*70+70 And MouseY() > 260-tier.raus And MouseY() < 260-tier.raus+70 And tier.istraus = 1
					mpstate = 1
					If mh 
						PlaySound snd_pop
						tier.hit = Not tier.hit
					EndIf 
					SetAlpha .7
					SetColor 0,255,0
				EndIf 
				
				If tier.hit = 1
					SetColor 0,171,100
				EndIf 
				DrawImage img_tier,53+tier.id*70,260-tier.raus,tier.frame
				SetColor 255,255,255
				SetAlpha 1
				If HILFE = 1
					SetColor 0,0,0
					DrawText "2^"+String(7-tier.id),53+tier.id*80,0
					SetColor 255,255,255
				EndIf 
		Next 
		
	End Function 
	
	Function Anzeige()
		If gamestart = 1
		SetImageFont fnt_digit
		If Not zahl And start = 0 
			zahl = Rand(255)
		 	NEWANITEXT(0,300-(TextWidth(zahl)/2),26,zahl,132,181,73,1)
			start = 1
		EndIf 
		SetImageFont fnt_gaps
		EndIf 
		
		If BUTTON(20,435,but_mute,Not sound)
			sound = Not sound 
		EndIf 
		
		If BUTTON(585,435,but_ende,Null)
			End 
		EndIf 
		
		If BUTTON(585,380,but_neu,Null)
			zahl = 0
			start = 0
			gamestart = 0
			punkte = 0
			counter = 3
			DELETEANITEXT(0)
			For tier:TTier = EachIn TListTier
				tier.raus = 0
				tier.istraus = 0
				tier.hit = 0
			Next 
		EndIf 
		
		If BUTTON(20,10,but_voll,VOLLBILD)
			If VOLLBILD = 0
				EndGraphics 
				Graphics 640,480,16,60
				VOLLBILD = 1
			Else
				EndGraphics
				Graphics 640,480
				VOLLBILD = 0 
			EndIf 
		EndIf 
		If gamestart = 1
			If BUTTON(640/2-(ImageWidth(but_solve)/2),300,but_solve,Null)
				 SOLVE()
			EndIf 
		EndIf 
		
		If gamestart = 1
			SetImageFont fnt_digit2
				SetColor 0,0,0
				DrawText counter+"s",542,8
				SetColor 131,171,40
				DrawText counter+"s",540,6
				SetColor 255,255,255
			SetImageFont fnt_gaps
		ElseIf gamestart = 0 
			SetImageFont fnt_digit3
				If counter<1
					gamestart = 1
					counter = 90
					SetAlpha 0
					PlaySound snd_horn
				EndIf 
				SetColor 0,0,0
				DrawText counter+"s",300-(TextWidth(counter)/2)+2,38
				SetColor 0+counter*70,196,37
				DrawText counter+"s",300-(TextWidth(counter)/2),36
				SetColor 255,255,255
				SetAlpha 1
			SetImageFont fnt_gaps
		EndIf 
		
		If gamestart = 2
			SetImageFont fnt_digit2
				If ffa<=1
					ffa:+.005
				Else
					If ffb<60
						ffb:+1
					Else
						If p<punkte
							p:+1
						EndIf 
					EndIf 
				EndIf 
				
				SetAlpha ffa
				SetColor 0,0,0
				DrawText "Game",202,244-ffa*10
				SetColor 255,0,0
				DrawText "Game",200,242-ffa*10
				SetColor 0,0,0
				DrawText "over",322,224+ffa*10
				SetColor 255,255,255
				DrawText "over",320,222+ffa*10
				SetColor 0,0,0	
				DrawText "Punkte: "+p,-300+ffb*10+2,272
				SetColor 255,255,255	
				DrawText "Punkte: "+p,-300+ffb*10,270
							
				SetAlpha 1
			SetImageFont fnt_gaps
		EndIf 
			
					
		If FALSCH = 1 
			SetImageFont fnt_digit
				SetColor 0,0,0
				SetAlpha ff
				If ff>=0
					ff:-.05
				Else
					ff = 1
					FALSCH = 0
					FALSCHZEIT = 0
				EndIf 
				DrawText "-"+FALSCHZEIT+"s",252,244-ff*10
				SetColor 255,0,0
				DrawText "-"+FALSCHZEIT+"s",250,242-ff*10
				SetColor 255,255,255
				SetAlpha 1
			SetImageFont fnt_gaps
		EndIf
		If RICHTIG = 1 
			SetImageFont fnt_digit
				SetColor 0,0,0
				SetAlpha ff
				If ff>=0
					ff:-.05
				Else
					ff = 0
					RICHTIG = 0
				EndIf 
				DrawText "+25s",252,244+ff*10
				SetColor 0,255,0
				DrawText "+25s",250,242+ff*10
				SetColor 255,255,255
				SetAlpha 1
			SetImageFont fnt_gaps
		EndIf  
		
		If counter<=0 And gamestart <> 2 ' Gameover
			ffa = 0
			ffb = 0
			gamestart = 2
			DELETEANITEXT(0)
			For tier:TTier = EachIn TListTier
				tier.raus = 0
				tier.istraus = 0
			Next 
		EndIf 
	
	End Function 
	
	Function ZeigeZahl:Int(zahl:Int)
	
		
		text:String = String(zahl)
		For i:Int = 0 To Len(text)
			read:String = Mid(text,i,1)
			Select read
				Case "0"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,0
					SetScale 1,1
				Case "1"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,1
					SetScale 1,1
				Case "2"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,2
					SetScale 1,1
				Case "3"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,3
					SetScale 1,1

				Case "4"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,4
					SetScale 1,1

				Case "5"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,5
					SetScale 1,1

				Case "6"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,6
					SetScale 1,1

				Case "7"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,7
					SetScale 1,1

				Case "8"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,8
					SetScale 1,1
				Case "9"
					SetScale sx,sy
					DrawImage img_digits,180+(i*50),30,9
					SetScale 1,1
			End Select
		Next 
		
		SetBlend LIGHTBLEND
		DrawImage img_flare,480,-70
		SetBlend ALPHABLEND			
						
	End Function 
	
	
Function NEWANITEXT(id,x,y,text$,r,g,b,v)
txt:ANITEXT = New ANITEXT
		txt.id = id
		txt.x = x
		txt.y = y
		txt.text = text
		txt.r = r
		txt.g = g
		txt.b = b
		txt.v = v
		
		For i = 0 To Len(txt.text)
			txt.split[i] = Mid(txt.text,i,1)
			If i <= Len(txt.text)/2
			 txt.mov[i] = i*(i-1)
			Else
			 txt.mov[i] = txt.mov[i-1]-2
		    EndIf 
		Next 
	ListAddLast(TListAniText,txt)
	
End Function 

Function DELETEANITEXT(id)
For txt:ANITEXT =EachIn TListAniText
	If txt.id = id
		ListRemove(TListAnitext,txt)
	EndIf
Next
End Function 


Function Animate(id)
	For txt:ANITEXT = EachIn TListAniText
	If id = 0 Then SetImageFont fnt_digit Else SetImageFont fnt_gaps
	If txt.id = id 
		For i = 0 To Len(txt.text)
		
		If txt.movdir[i] = 0
			If txt.mov[i] < 8
				txt.mov[i]:+.21
			Else
				txt.movdir[i] = 1
			EndIf 
		Else
			If txt.mov[i]>=0
				txt.mov[i]:-.21
			Else
				txt.movdir[i] = 0
			EndIf
		EndIf 	
			SetColor 0,0,0
			If id = 0 Then DrawText txt.split[i],txt.x+i*36+1,txt.y-txt.mov[i]+1 Else DrawText txt.split[i],txt.x+i*13+1,txt.y-txt.mov[i]+1 
			If txt.v = 0
				SetColor txt.r,txt.g,txt.b
			Else
				SetColor txt.r-i*10,txt.g-i*10,txt.b-i*10
			EndIf 
			If id = 0 Then DrawText txt.split[i],txt.x+i*36,txt.y-txt.mov[i] Else  DrawText txt.split[i],txt.x+i*13,txt.y-txt.mov[i]
			SetColor 255,255,255
		Next 
	EndIf 
	SetImageFont fnt_gaps
	Next
End Function

Function BUTTON:Int(x:Int,y:Int,img:TImage,was:Int)
If was = 0 Then DrawImage img,x,y,0 Else DrawImage img,x,y,1

	If MouseX() > x And MouseX() < x+ImageWidth(img) And MouseY() > y And MouseY() < y+ImageHeight(img)
		If mh = 1
			Return 1
		EndIf
		If was = 0 Then DrawImage img,x,y,1 Else DrawImage img,x,y,0
	EndIf 
	
End Function

Function SOLVE()	' Spiel lsen ?!
	
	For tier:TTier = EachIn TListTier
		ergebnis:+tier.hit * (2^(7-tier.id))
		If tier.hit = 0
			tier.raus = 0
			tier.bleib = 1
		EndIf 
	Next	
		If ergebnis = zahl
			PlaySound snd_right
			zahl = 0
			start = 0
			punkte:+1
			counter:+25
			DELETEANITEXT(0)
			RICHTIG = 1
			ergebnis = 0
			such = Null 
			SOLV = 1
				For tier:TTier = EachIn TListTier
					tier.hit = 0
					tier.istraus = 0
					tier.raus = 0
					tier.bleib = 0
					tier.showi = 0
					tier.show = 0
				Next  
		Else
			PlaySound snd_wrong
			zahl = 0
			start = 0
			counter:/2
			ergebnis = 0
			DELETEANITEXT(id)
			FALSCH = 1
			such = Null 
			FALSCHZEIT = counter/2
			SOLV = 0
				For tier:TTier = EachIn TListTier
					tier.hit = 0
					tier.istraus = 0
					tier.raus = 0
					tier.bleib = 0
					tier.showi = 0
					tier.show = 0
				Next  
		EndIf
					
End Function 

	
