
	'______________________________________________________________________
	'Die Klasse TKlaviertaste organisiert die Darstellung und Verwendung der Klaviertasten.
	'______________________________________________________________________



TKlaviertaste.Bild = LoadAnimImage("Medien/Bilder/Klaviertasten.png", 47, 294, 0, 5)
TKlaviertaste.Tastatur_positionieren(450,288)
Global Klaviertaste:TKlaviertaste[TonAnzahl+1]
Global Ist_die_Taste_weiss:Int[] = [1,0,1,0,1,1,0,1,0,1,0,1,1,0,1,0,1,1]
For Local Kt:Int = 0 To TonAnzahl
	Klaviertaste[Kt] = TKlaviertaste.erschaffen(Kt)
Next


'______________________________________________________________________
Type TKlaviertaste
	'----------------------------------------------------------------------
	Global Bild:TImage, TastaturLinks:Int, TastaturOben:Int, TastaturMitte:Int, TastaturUnten:Int
	'----------------------------------------------------------------------
	Field Index:Int, Frame:Int, Farbe:Int '(0 = weisse Taste, 1 = schwarze Taste)
	Field Links:Int, Rechts:Int, Mitte:Int, InnenLinks:Int, InnenRechts:Int
	Field angeschlagen:Int, aktiv:Byte   'es muss unterschieden werden, ob ein Ton neu erklingen oder gehalten werden soll.
	Field Kanal:TChannel
	'----------------------------------------------------------------------
	Function Tastatur_positionieren(L:Int, O:Int) 'bitte VOR der Erschaffung einer ersten Taste
		TastaturLinks = L
		TastaturOben = O
		TastaturMitte = O + 196
		TastaturUnten = O + 294
	End Function
	'----------------------------------------------------------------------
	Function erschaffen:TKlaviertaste(Neuer_Index:Int)
		Local NeueTaste:TKlaviertaste = New TKlaviertaste
		NeueTaste.Index = Neuer_Index
		'die folgende etwas komplizierte Differenzierung ist notwendig, weil die
		'Platzierung der schwarzen und weissen Tasten sich gegenseitig ueberlagern:
		If Ist_die_Taste_weiss[Neuer_Index] = True Then
			If Neuer_Index = 0 Then
				NeueTaste.Links = TastaturLinks
			ElseIf Klaviertaste[Neuer_Index-1].Farbe = 0 Then '(weiss)
				NeueTaste.Links = Klaviertaste[Neuer_Index-1].Rechts
			Else '(schwarz)
				NeueTaste.Links = Klaviertaste[Neuer_Index-1].Rechts - 13
			End If
			NeueTaste.Rechts = NeueTaste.Links + 49
			NeueTaste.InnenLinks = NeueTaste.Links
			NeueTaste.InnenRechts = NeueTaste.Rechts
			If Neuer_Index = TonAnzahl Then
				NeueTaste.Frame = 3
			ElseIf Neuer_Index = 0 Or Neuer_Index = 12 Or Neuer_Index = 5 Then
					NeueTaste.InnenRechts = NeueTaste.Rechts - 13
					NeueTaste.Frame = 0
			ElseIf Neuer_Index = 4 Or Neuer_Index = 16 Or Neuer_Index = 11 Then
				NeueTaste.InnenLinks = NeueTaste.InnenLinks + 13
				NeueTaste.Frame = 2
			Else	
				NeueTaste.InnenLinks = NeueTaste.InnenLinks + 13
				NeueTaste.InnenRechts = NeueTaste.Rechts - 13
				NeueTaste.Frame = 1
			End If			
		Else 'die Taste ist schwarz!
			NeueTaste.Farbe = 1
			NeueTaste.Links = Klaviertaste[Neuer_Index-1].Rechts - 13
			NeueTaste.Rechts = NeueTaste.Links + 27
			NeueTaste.Frame = 4
		End If
		Return NeueTaste
	End Function
	'----------------------------------------------------------------------
	Function Tastatur_verwenden()
		For Local Kt:Int = 0 To TonAnzahl
			Klaviertaste[Kt].einzelne_Taste_verwenden()
		Next
	End Function
	'----------------------------------------------------------------------
	Method einzelne_Taste_verwenden()
		aktiv = False
		'Die folgende Abfrage ist tatsaechlich fuer ALLE Tasten notwendig, sonst wird ein Klang.verstummen()
		'nicht eintreten, wenn man von der Taste nach oben oder unten herunterrutscht:
		If Maus.y >= TastaturOben And Maus.y <= TastaturUnten Then
			If Maus.x >= Links And Maus.x < Rechts Then
				If (Farbe = 0 And (Maus.y > TastaturMitte Or (Maus.x >= InnenLinks And Maus.x < InnenRechts))) Or (Farbe = 1 And Maus.y < TastaturMitte) Then
					If Maus.Aktion > 0 Then
						DrawImage Bild, Links, TastaturOben, Frame
						PC_Taste[Index].malen()
						aktiv = True
						If angeschlagen = 0 Then
							angeschlagen = 1
							Kanal = Ton[Index].erklingen(Stimme[1].Instrument)
						ElseIf angeschlagen = 1 Then
							angeschlagen = 2
						End If
					End If
				End If
			End If
		End If
		If angeschlagen > 0 Then
			If aktiv = False Then
				angeschlagen = -1	'Erkennungszeichen fuer den Moment des Loslassens (wichtig fuer das Aufnehmen von Melodien)
				TTon.verstummen(Index, Kanal)
			End If
		ElseIf angeschlagen = -1 Then
			angeschlagen = 0
		End If
	End Method
	'----------------------------------------------------------------------
	Method malen()
		'dieses Prozedur steht fuer andere Objekte zur Verfuegung, deren Steuerung
		'ebenfalls durch die entsprechende Klaviertaste demonstriert werden soll
		DrawImage Bild, Links, TastaturOben, Frame
	End Method
	'----------------------------------------------------------------------
End Type
