
	'______________________________________________________________________
	'Mit der folgenden TNote-Klasse wird ein ziemlich umfangreicher Objekt-Baustein definiert,
	'welcher mit all seinen notwendigen Informationen in der TMelodie-Klasse Verwendung findet.
	'______________________________________________________________________



Global NotenkopfBild:TImage = LoadAnimImage("Medien/Bilder/Notenkopf.png", 15, 9, 0, 5)
SetImageHandle(NotenkopfBild, 4, 4)
Global NotenhalsBild:TImage = LoadAnimImage("Medien/Bilder/Notenhals.png", 17, 50, 0, 7)
SetImageHandle(NotenhalsBild, 3, 24)
Global VorzeichenBild:TImage = LoadAnimImage("Medien/Bilder/Vorzeichen.png", 22, 33, 0, 6)
SetImageHandle(Vorzeichenbild, 20,17)
TNote.Sechzehntel_x_Position_berechnen(70, 974)

'______________________________________________________________________

Type TNote
	'----------------------------------------------------------------------
	Global Sechzehntel_x_Position:Int[160]
						   'eigentlich: [MaximalTaktAnzahl * (4 * Viertel_pro_Takt + 4)]
	'----------------------------------------------------------------------
	Field Index:Int  'die Tonhoehe
	Field ExakterStart:Int   'das entspricht der Dauer, die seit dem MelodieAufnahmeStart vergangen ist
	Field QuantisierterStart:Int	'hier nun auf die zur Verfuegung stehenden Notenwerte quantisiert
	Field ExakteDauer:Int, QuantisierteDauer:Int		'dasselbe fuer die Dauer der Note
	Field ExakterStop:Int, QuantisierterStop:Int		'und das Ende der Note
	Field aktiv:Byte, Aufnahmequelle:Byte
	Field x:Int, y:Int, NotenkopfIndex:Int, NotenhalsIndex:Int, VorzeichenbildIndex:Int
	Field Kanal:TChannel
	'----------------------------------------------------------------------
	Function aufnehmen:TNote(Index:Int, Aufnahmequelle:Int, vergangene_Zeit:Int, c1_y:Int)
		Local Note:TNote = New TNote
		Note.ExakterStart = Min(vergangene_Zeit, MaximalDauer-1)
		If Note.ExakterStart < -Quantisierung[1] Then Return Null	'beim Aufnehmen wird 1 Takt vorgezaehlt, dann darf
														'man nicht schon einen MinimalNotenwert zu frueh einsetzen,
														'vorher gespielt Toene werden also ignoriert.
		Note.QuantisierterStart = (Note.ExakterStart+Quantisierung[2]) / Quantisierung[1] * Quantisierung[1]
		If Note.QuantisierterStart >= MaximalDauer Then Return Null
		Note.Index = Index
		Note.Aufnahmequelle = Aufnahmequelle
		Note.x = Sechzehntel_x_Position[Note.QuantisierterStart / Quantisierung[3]]
		Note.y_und_Vorzeichen_berechnen(c1_y)
		Return Note
	End Function
	'----------------------------------------------------------------------
	Method y_und_Vorzeichen_berechnen(c1_y:Int)
		VorzeichenbildIndex = 0
		Select Index
		Case 0
			Select Noten_Name[Index Mod 12]
			Case "c"
				y = c1_y
			Default ''his"
				y = c1_y + 3
				VorzeichenbildIndex = 1
			End Select
		Case 1
			Select Noten_Name[Index Mod 12]
			Case "cis"
				y = c1_y
				VorzeichenbildIndex = 1
			Default '"des"
				y = c1_y - 4
				VorzeichenbildIndex = 2
			End Select
		Case 2
			Select Noten_Name[Index Mod 12]
			Case "d"
				y = c1_y - 4
			Default ''eses"
				y = c1_y - 7
				VorzeichenbildIndex = 4
			End Select
		Case 3
			Select Noten_Name[Index Mod 12]
			Case "es"
				y = c1_y - 7
				VorzeichenbildIndex = 2
			Default ''dis"
				y = c1_y - 4
				VorzeichenbildIndex = 1
			End Select
		Case 4
			Select Noten_Name[Index Mod 12]
			Case "e"
				y = c1_y - 7
			Default ''fes"
				y = c1_y - 11
				VorzeichenbildIndex = 2
			End Select
		Case 5
			Select Noten_Name[Index Mod 12]
			Case "f"
				y = c1_y - 11
			Default ''eis"
				y = c1_y - 7
				VorzeichenbildIndex = 1
			End Select
		Case 6
			Select Noten_Name[Index Mod 12]
			Case "fis"
				y = c1_y - 11
				VorzeichenbildIndex = 1
			Default ''ges"
				y = c1_y - 14
				VorzeichenbildIndex = 2
			End Select
		Case 7
			Select Noten_Name[Index Mod 12]
			Case "g"
				y = c1_y - 14
			Default ''fisis"
				y = c1_y - 11
				VorzeichenbildIndex = 3
			End Select
		Case 8
			Select Noten_Name[Index Mod 12]
			Case "gis"
				y = c1_y - 14
				VorzeichenbildIndex = 1
			Default ''as"
				y = c1_y - 18
				VorzeichenbildIndex = 2
			End Select
		Case 9
			Select Noten_Name[Index Mod 12]
			Case "a"
				y = c1_y - 18
			Default ''heses"
				y = c1_y - 21
				VorzeichenbildIndex = 4
			End Select
		Case 10
			Select Noten_Name[Index Mod 12]
			Case "b"
				y = c1_y - 21
				VorzeichenbildIndex = 2
			Default ''ais"
				y = c1_y - 18
				VorzeichenbildIndex = 1
			End Select
		Case 11
			Select Noten_Name[Index Mod 12]
			Case "h"
				y = c1_y - 21
			Default ''ces"
				y = c1_y - 25
				VorzeichenbildIndex = 2
			End Select
		Case 12
			Select Noten_Name[Index Mod 12]
			Case "c"
				y = c1_y - 25
			Default ''his"
				y = c1_y - 21
				VorzeichenbildIndex = 1
			End Select
		Case 13
			Select Noten_Name[Index Mod 12]
			Case "cis"
				y = c1_y - 25
				VorzeichenbildIndex = 1
			Default ''des"
				y = c1_y - 28
				VorzeichenbildIndex = 2
			End Select
		Case 14
			Select Noten_Name[Index Mod 12]
			Case "d"
				y = c1_y - 28
			Default ''eses"
				y = c1_y - 32
				VorzeichenbildIndex = 4
			End Select
		Case 15
			Select Noten_Name[Index Mod 12]
			Case "es"
				y = c1_y - 32
				VorzeichenbildIndex = 2
			Default ''dis"
				y = c1_y - 28
				VorzeichenbildIndex = 1
			End Select
		Case 16
			Select Noten_Name[Index Mod 12]
			Case "e"
				y = c1_y - 32
			Default ''fes"
				y = c1_y - 35
				VorzeichenbildIndex = 2
			End Select
		Default '(case 17)
			Select Noten_Name[Index Mod 12]
			Case "f"
				y = c1_y - 35
			Default ''eis"
				y = c1_y - 32
				VorzeichenbildIndex = 1
			End Select
		End Select
	End Method
	'----------------------------------------------------------------------
	Method Dauer_feststellen(vergangene_Zeit:Int) 'fuer die Aufnahme, bei der ja vorher noch nicht feststeht, wie lange ein Ton ausgehalten wird.
		ExakterStop = vergangene_Zeit
		ExakteDauer = ExakterStop - ExakterStart
		QuantisierteDauer = Min(MaximalNotenwert, Max(Quantisierung[1], (ExakteDauer+Quantisierung[2]) / Quantisierung[1] * Quantisierung[1]))
		Local ZensurIndex:Int = QuantisierteDauer/Quantisierung[3]
		While DauerZensur[ZensurIndex] = True
			ZensurIndex = ZensurIndex - 1
			QuantisierteDauer = QuantisierteDauer - Quantisierung[3]
		Wend
		NotenkopfIndex = NotenkopfIndizes[ZensurIndex]
		NotenhalsIndex = NotenhalsIndizes[ZensurIndex]
		If Index > 11 And NotenhalsIndex <> 0 Then NotenhalsIndex = NotenhalsIndex + 3   'nach unten!
		'die folgende quasi symbolische Differenz - 1 hat nur einen mathematisch-technischen
		'Grund in der Method eventuelle_Pausen_fuellen() von TMelodie
		QuantisierterStop = Min(MaximalDauer-1, QuantisierterStart + QuantisierteDauer - 1)
	End Method
	'----------------------------------------------------------------------
	Method abspielen(vergangene_Zeit:Int, Instrument:Int)
		If aktiv = 0 Then	'Note ist noch nicht dran...
			If vergangene_Zeit >= QuantisierterStart Then 'aber jetzt!
			'If vergangene_Zeit >= ExakterStart Then 'aber jetzt!

				aktiv = 1
				Klaviertaste[Index].malen()
				PC_Taste[Index].malen()
				Kanal = Ton[Index].erklingen(Instrument)
				SetColor 255,128,0
				Note_zeichnen()
				SetColor 255,255,255
			End If
		ElseIf aktiv = 1 Then 'Note wurde angespielt und wird zeichnerisch hervorgehoben.
			If vergangene_Zeit >= QuantisierterStop Then 'vorbei!
			'If vergangene_Zeit >= ExakterStop Then 'vorbei!
				aktiv = 2
				TTon.verstummen(Index, Kanal)
			Else
				Klaviertaste[Index].malen()
				PC_Taste[Index].malen()
				SetColor 255,128,0
				Note_zeichnen()
				SetColor 255,255,255
			End If
		End If	
	End Method
	'----------------------------------------------------------------------
	Method Note_zeichnen()
		'gegenfalls besondere Lage, verursacht durch zu nahegelegene Nachbarn?
		DrawImage Notenkopfbild, x, y, NotenkopfIndex
		DrawImage Notenhalsbild, x, y, NotenhalsIndex
		DrawImage Vorzeichenbild, x, y, VorzeichenbildIndex
		'Sonderfaelle zusaetzliche untere Hilfslinie:
		If Index = 0 Then
			If Noten_Name[0] = "c" Then
				DrawRect x-8, y, 18, 1
			Else 'If Noten_Name[0] = "his" Then
				DrawRect x-8, y-3, 18, 1
			End If
		ElseIf Index = 1 Then
			If Noten_Name[1] = "cis" Then DrawRect x-8, y, 18, 1
		End If
	End Method
	'----------------------------------------------------------------------
	Method Note_besonders_zeichnen()
		'gegenfalls besondere Lage, verursacht durch zu nahegelegene Nachbarn?
		SetColor 255,128,0
		DrawImage Notenkopfbild, x, y, NotenkopfIndex
		DrawImage Notenhalsbild, x, y, NotenhalsIndex
		DrawImage Vorzeichenbild, x, y, VorzeichenbildIndex
		'Sonderfaelle zusaetzliche untere Hilfslinie:
		If Index = 0 Then
			If Noten_Name[0] = "c" Then
				DrawRect x-8, y, 18, 1
			Else 'If Noten_Name[0] = "his" Then
				DrawRect x-8, y-3, 18, 1
			End If
		ElseIf Index = 1 Then
			If Noten_Name[1] = "cis" Then DrawRect x-8, y, 18, 1
		End If
		SetColor 0,0,0
	End Method	
	'----------------------------------------------------------------------
	Method mit_anderer_Note_vergleichen:Byte(AndereNote:TNote)
		If AndereNote.QuantisierterStart <> QuantisierterStart Then Return False
		If AndereNote.Index <> Index Then Return False
		If AndereNote.QuantisierteDauer <> QuantisierteDauer Then Return False
		Return True
	End Method
	'=======================================
	Function Sechzehntel_x_Position_berechnen(Links:Float, Gesamtbreite:Int)
		Local Sechzehntel_im_Takt:Int = 4 * Viertel_pro_Takt
		Local Sechzehntelsumme:Int = MaximalTaktAnzahl * Sechzehntel_im_Takt
		Local Breite_pro_Sechzehntel:Float = 1.0 * Gesamtbreite / (MaximalTaktAnzahl * (Sechzehntel_im_Takt + 2))
		Local Taktstrichindex:Int = 0
		Taktstrich_x = New Int[MaximalTaktAnzahl+1]
		For Local s:Int = 0 To Sechzehntelsumme - 1
			Sechzehntel_x_Position[s] = Links
			If s Mod Sechzehntel_im_Takt <> Sechzehntel_im_Takt-1 Then
				Links = Links + Breite_pro_Sechzehntel
			Else
				Taktstrich_x[Taktstrichindex] = Links + Breite_pro_Sechzehntel
				Taktstrichindex = Taktstrichindex + 1
				Links = Links + 3 * Breite_pro_Sechzehntel
			End If
		Next
	End Function
	'----------------------------------------------------------------------
End Type

'______________________________________________________________________
