
	'______________________________________________________________________
	'Hier wird die Noten- bzw. Musikeingabe per PC-Tastatur organisiert,
	'd.h. es werden die entsprechenden Key-Inputs abgefragt und umgesetzt
	'bzw. weitergeleitet an andere Objekte. Die visuelle Darstellung auf dem
	'Bildschirm dient nur zur Orientierung und zum Erlernen, ist aber nicht
	'mit der Maus bedienbar - wozu auch?
	'______________________________________________________________________


TPC_Taste.Bild = LoadAnimImage("Medien/Bilder/PC_Tasten.png", 30, 30, 0, 18)
TPC_Taste.Tastatur_positionieren(33,514)
Global PC_Taste:TPC_Taste[TonAnzahl+1]
For Local Pt:Int = 0 To TonAnzahl
	PC_Taste[Pt] = TPC_Taste.erschaffen(Pt)
Next

'______________________________________________________________________

Type TPC_Taste
	'----------------------------------------------------------------------
	Global Bild:TImage, TastaturLinks:Int, TastaturOben:Int
	'----------------------------------------------------------------------
	Field Index:Int, KeyCode:Int, Farbe:Int '(0 = weisse Taste, 1 = schwarze Taste)
	Field Links:Int, Oben:Int
	Field angeschlagen:Int, aktiv:Byte   'es muss unterschieden werden, ob ein Ton neu erklingen oder gehalten werden soll.
	Field Kanal:TChannel
	'----------------------------------------------------------------------
	Function Tastatur_positionieren(L:Int, O:Int) 'bitte VOR der Erschaffung einer ersten Taste
		TastaturLinks = L
		TastaturOben = O
	End Function
	'----------------------------------------------------------------------
	Function erschaffen:TPC_Taste(Neuer_Index:Int)
		Local NeueTaste:TPC_Taste = New TPC_Taste
		NeueTaste.Index = Neuer_Index
		If Ist_die_Taste_weiss[Neuer_Index] = True Then
			NeueTaste.Oben = TastaturOben + 35
		Else 'die Taste ist schwarz
			NeueTaste.Oben = TastaturOben			
		End If
		'Die umstaendliche individuelle Platzierung soll jener der echten Computertastatur nahekommen:
		Local VergaengerBezugsIndex:Int[] = [0,0,0,2,2,4,5,5,7,7,9,9,11,12,12,14,14,16]
		Local VerschiebSummand:Int[] = [0,26,35,26,35,35,26,35,26,35,26,35,35,26,35,26,35,35]
		If Neuer_Index > 0 Then
			NeueTaste.Links = PC_Taste[VergaengerBezugsIndex[Neuer_Index]].Links + VerschiebSummand[Neuer_Index]
		Else
			NeueTaste.Links = TastaturLinks
		End If
		Local PC_Keycode:Int[] = [KEY_A, KEY_W, KEY_S, KEY_E, KEY_D, KEY_F, KEY_T, KEY_G, KEY_Z, KEY_H, KEY_U, KEY_J, KEY_K, KEY_O, KEY_L, KEY_P, 192, 222]
		?MacOS 'auf MacOSX-Systemen sind die Keycodes fuer z und fuer ae anders:
			PC_Keycode[8] = 89
			PC_Keycode[16] = 186
		?
		?Linux 'auf Linux-Systemen sind die Keycodes fuer ae und oe anders:
			PC_Keycode[16] = 246
			PC_Keycode[17] = 163
		?
		NeueTaste.KeyCode = PC_Keycode[Neuer_Index]
		Return NeueTaste
	End Function
	'----------------------------------------------------------------------
	Function Tastatur_verwenden()
		For Local Pt:Int = 0 To TonAnzahl
			PC_Taste[Pt].einzelne_Taste_verwenden()
		Next
	End Function
	'----------------------------------------------------------------------
	Method einzelne_Taste_verwenden()
		aktiv = False
		If KeyDown(KeyCode) Then
			DrawImage Bild, Links, Oben, Index
			Klaviertaste[Index].malen()
			aktiv = True
			If angeschlagen = 0 Then
				angeschlagen = True
				Kanal = Ton[Index].erklingen(Stimme[1].Instrument)
			ElseIf angeschlagen = 1 Then
				angeschlagen = 2
			End If
		ElseIf angeschlagen > 0 Then
			angeschlagen = -1	'Erkennungszeichen fuer den Moment des Loslassens (wichtig fuer das Aufnehmen von Melodien)
			TTon.verstummen(Index, Kanal)
		ElseIf angeschlagen = -1 Then
			angeschlagen = 0
		End If
	End Method
	'----------------------------------------------------------------------
	Method malen()
		'dieses Prozedur steht fuer andere Objekte zur Verfuegung, deren Steuerung
		'ebenfalls durch die entsprechende PC_Taste demonstriert werden soll
		DrawImage Bild, Links, Oben, Index
	End Method
	'----------------------------------------------------------------------
End Type