
	'_________________________________________________________________________________
	'Hier folgt alles Notwendige, um die Steuerung der Befehlsschalter und Auswahloptionen zu gestatten.
	'Die Auswahloptionen sind nicht nur per Mausklick, sondern auch mit dem Mausrad zu bedienen.
	'_________________________________________________________________________________
	

Global MemoVerzeichnis:String = AppDir$ + "/Lektionen/" 'zum Merken des Verzeichnisses beim Laden/Speichern
Global Menuschalter:TImage = LoadAnimImage("Medien/Bilder/Menuschalter.png", 48, 27, 0, 10)
Global Optionenschalter:TImage = LoadImage("Medien/Bilder/Optionenschalter.png")
Global Sprechblase:TImage = LoadImage("Medien/Bilder/Sprechblase.png")

'_______________________________________________________________________

Function Menu_verwenden()
	'---------------------------
	If Stimme[0].Modus = 2 Then DrawImage MenuSchalter, 672, 246, 4
	If Stimme[1].Modus = 2 Then DrawImage MenuSchalter, 723, 246, 5
	If Stimme[1].Modus = 1 Then DrawImage MenuSchalter, 876, 246, 8
	'---------------------------
	If Maus.y < 273 Then
		If Maus.y > 245 Then
			If Maus.x > 461 Then
				If Maus.x < 512 Then
					DrawImage Sprechblase, 380, 271
					SetColor 0,0,0
					DrawText "Neu", 434, 313
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 462, 246, 0
					ElseIf Maus.Aktion = -1 Then
						If Stimme[0].Modus = 1 Then
							Stimme[0].aufnehmen_stoppen()
						ElseIf Stimme[0].Modus = 2 Then
							Stimme[0].abspielen_stoppen()
						End If
						If Stimme[1].Modus = 1 Then
							Stimme[1].aufnehmen_stoppen()
						ElseIf Stimme[1].Modus = 2 Then
							Stimme[1].abspielen_stoppen()
						End If
						ClearList(Stimme[0].Notenliste)
						ClearList(Stimme[0].Pausenliste)
						ClearList(Stimme[1].Notenliste)
						ClearList(Stimme[1].Pausenliste)
						SkaliertesTextfeld.leeren()
					End If
				ElseIf Maus.x < 563 Then
					DrawImage Sprechblase, 431, 271
					SetColor 0,0,0
					DrawText "Datei", 479, 306
					DrawText "laden", 479, 324
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 513, 246, 1
					ElseIf Maus.Aktion = -1 Then
						'-------------------------------------------------------
						Local Dateiname:String = RequestFile("Musiktrainer-Datei laden",,False,MemoVerzeichnis)
						If Dateiname <> "" Then
							MemoVerzeichnis = Dateiname
							Local DateiStrom:TStream = ReadStream(Dateiname)
							If DateiStrom <> Null Then
								Viertel_pro_Takt = ReadInt(DateiStrom)
								Schlaege_pro_Minute = ReadInt(DateiStrom)
								Quantisierung[0] = ReadInt(DateiStrom)
								Quantisierungsdaten_anpassen()
								Quantisierung[5] = Quantisierung[3]		'Memo-Sechzehntel (fuer Tempowechsel notwendig)
								TNote.Sechzehntel_x_Position_berechnen(70, 974)
								EnharmonikIndex = ReadInt(DateiStrom)
								Noten_Namen_definieren()
								Stimme[0].Instrument = ReadInt(DateiStrom)
								Stimme[1].Instrument = ReadInt(DateiStrom)
								For Local s:Int = 0 To 1
									ClearList(Stimme[s].Notenliste)
									Local Anzahl:Int = ReadInt(DateiStrom)
									For Local n:Int = 1 To Anzahl
										Local Note:TNote = New TNote
										Note.Index = ReadInt(DateiStrom)
										Note.ExakterStart = ReadInt(DateiStrom)
										Note.QuantisierterStart = ReadInt(DateiStrom)
										Note.ExakteDauer = ReadInt(DateiStrom)
										Note.QuantisierteDauer = ReadInt(DateiStrom)
										Note.ExakterStop = ReadInt(DateiStrom)
										Note.QuantisierterStop = ReadInt(DateiStrom)
										Note.x = ReadInt(DateiStrom)
										Note.y = ReadInt(DateiStrom)
										Note.NotenkopfIndex = ReadInt(DateiStrom)
										Note.NotenhalsIndex = ReadInt(DateiStrom)
										Note.VorzeichenbildIndex = ReadInt(DateiStrom)
										ListAddLast(Stimme[s].Notenliste, Note)
									Next
									ClearList(Stimme[s].Pausenliste)
									Anzahl= ReadInt(DateiStrom)
									For Local p:Int = 1 To Anzahl
										Local Pause:TPause = New TPause
										Pause.x = ReadInt(DateiStrom)
										Pause.y = ReadInt(DateiStrom)
										Pause.PausenbildIndex = ReadInt(DateiStrom)
										ListAddLast(Stimme[s].Pausenliste, Pause)
									Next
								Next
								SkaliertesTextfeld.TextLaden(DateiStrom)
								CloseStream(DateiStrom)
							'-------------------------------------------------------
							Else
								Notify "Fehlermeldung: Es konnte keine Datei mit dem Namen~n'" + Dateiname + "'~ngeladen werden."
							End If
							'-------------------------------------------------------
						End If
						FlushMouse()
						FlushKeys()
						Maus.Aktion = -1
					End If
				ElseIf Maus.x < 614 Then
					DrawImage Sprechblase, 482, 271
					SetColor 0,0,0
					DrawText "Datei", 530, 306
					DrawText "speichern", 522, 324
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 564, 246, 2
					ElseIf Maus.Aktion = -1 Then
						'-------------------------------------------------------
						Local Dateiname:String = RequestFile("Musiktrainer-Datei speichern", , True, MemoVerzeichnis)
						If Dateiname <> "" Then
							MemoVerzeichnis = Dateiname
							Local DateiStrom:TStream = WriteStream(Dateiname)
							If DateiStrom <> Null Then
								WriteInt(DateiStrom, Viertel_pro_Takt)
								WriteInt(DateiStrom, Schlaege_pro_Minute)
								WriteInt(DateiStrom, Quantisierung[0])
								WriteInt(DateiStrom, EnharmonikIndex)
								WriteInt(DateiStrom, Stimme[0].Instrument)
								WriteInt(DateiStrom, Stimme[1].Instrument)
								For Local s:Int = 0 To 1
									WriteInt(DateiStrom, CountList(Stimme[s].Notenliste))
									For Local Note:TNote = EachIn Stimme[s].Notenliste
										WriteInt(DateiStrom, Note.Index)
										WriteInt(DateiStrom, Note.ExakterStart)
										WriteInt(DateiStrom, Note.QuantisierterStart)
										WriteInt(DateiStrom, Note.ExakteDauer)
										WriteInt(DateiStrom, Note.QuantisierteDauer)
										WriteInt(DateiStrom, Note.ExakterStop)
										WriteInt(DateiStrom, Note.QuantisierterStop)
										WriteInt(DateiStrom, Note.x)
										WriteInt(DateiStrom, Note.y)
										WriteInt(DateiStrom, Note.NotenkopfIndex)
										WriteInt(DateiStrom, Note.NotenhalsIndex)
										WriteInt(DateiStrom, Note.VorzeichenbildIndex)
									Next
									WriteInt(DateiStrom, CountList(Stimme[s].Pausenliste))
									For Local Pause:TPause = EachIn Stimme[s].Pausenliste
										WriteInt(DateiStrom, Pause.x)
										WriteInt(DateiStrom, Pause.y)
										WriteInt(DateiStrom, Pause.PausenbildIndex)
									Next
								Next
								SkaliertesTextfeld.TextSpeichern(DateiStrom)
								CloseStream(DateiStrom)
							'-------------------------------------------------------
							Else
								Notify "Fehlermeldung: Es konnte keine Datei mit dem Namen~n'" + Dateiname + "'~nerstellt werden."
							End If
						End If
						'-------------------------------------------------------
						FlushMouse()
						FlushKeys()
						Maus.Aktion = -1
					End If
				ElseIf Maus.x < 666 Then
					DrawImage Sprechblase, 533, 271
					SetColor 0,0,0
					DrawText "Programm", 565, 306
					DrawText "beenden", 574, 324
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 615, 246, 3
					ElseIf Maus.Aktion = -1 Then
						End
					End If
				ElseIf Maus.x < 721 Then
					DrawImage Sprechblase, 588, 271
					SetColor 0,0,0
					DrawText "1.Stimme", 623, 304
					DrawText "vorspielen lassen", 596, 322
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 672, 246, 4
					ElseIf Maus.Aktion = -1 Then
						If Stimme[0].Notenliste <> Null And CountList(Stimme[0].Notenliste) > 0 Then
							Stimme[0].abspielen_starten()
						ElseIf Stimme[1].Notenliste <> Null And CountList(Stimme[1].Notenliste) > 0 Then
							Notify "Die erste Stimme in der oberen Notenzeile~nenthlt zur Zeit noch keine Noten!~nMit dem ganz rechten Menuschalter knntest~ndu die zweite Stimme in die erste verschieben."
							FlushMouse()
							FlushKeys()
							Maus.Aktion = -1
						Else
							Notify "Die erste Stimme in der oberen Notenzeile~nenthlt zur Zeit noch keine Noten!~nEntweder du ldst eine Musiktrainer-Datei oder nimmst~nselbst eine eigene Melodie in der unteren Notenzeile auf~nund verschiebst sie hernach in die 1.Stimme."
							FlushMouse()
							FlushKeys()
							Maus.Aktion = -1
						End If
					End If
				ElseIf Maus.x < 772 Then
					DrawImage Sprechblase, 639, 271
					SetColor 0,0,0
					DrawText "2.Stimme", 674, 304
					DrawText "vorspielen lassen", 647, 322
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 723, 246, 5
					ElseIf Maus.Aktion = -1 Then
						If Stimme[1].Notenliste <> Null And CountList(Stimme[1].Notenliste) > 0 Then
							Stimme[1].abspielen_starten()
						Else
							Notify "Die zweite Stimme in der unteren Notenzeile~nenthlt zur Zeit noch keine Noten!~nDu kannst jedoch selbst eine Melodie aufnehmen."
							FlushMouse()
							FlushKeys()
							Maus.Aktion = -1
						End If
					End If
				ElseIf Maus.x < 823 Then
					DrawImage Sprechblase, 690, 271
					SetColor 0,0,0
					DrawText "1.und 2.Stimme", 706, 306
					DrawText "vorspielen lassen", 698, 324
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 774, 246, 6
					ElseIf Maus.Aktion = -1 Then
						If (Stimme[0].Notenliste <> Null And CountList(Stimme[0].Notenliste) > 0) Or (Stimme[1].Notenliste <> Null And CountList(Stimme[1].Notenliste) > 0) Then
							Stimme[0].abspielen_starten()
							Stimme[1].abspielen_starten()
						Else
							Notify "Beide Notenzeilen sind noch leer:~nEs gibt also nichts abzuspielen.~nLade erst eine Musiktrainer-Datei~noder nimm selbst eine Melodie auf."
							FlushMouse()
							FlushKeys()
							Maus.Aktion = -1
						End If
					End If
				ElseIf Maus.x < 874 Then
					DrawImage Sprechblase, 741, 271
					SetColor 0,0,0
					DrawText "Stop", 793, 313
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 825, 246, 7
					ElseIf Maus.Aktion = -1 Then
						If Stimme[0].Modus = 1 Then
							Stimme[0].aufnehmen_stoppen()
						ElseIf Stimme[0].Modus = 2 Then
							Stimme[0].abspielen_stoppen()
						End If
						If Stimme[1].Modus = 1 Then
							Stimme[1].aufnehmen_stoppen()
						ElseIf Stimme[1].Modus = 2 Then
							Stimme[1].abspielen_stoppen()
						End If
					End If
				ElseIf Maus.x < 925 Then
					DrawImage Sprechblase, 792, 271
					SetColor 0,0,0
					DrawText "2.Stimme", 830, 306
					DrawText "aufnehmen", 825, 324
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 876, 246, 8
					ElseIf Maus.Aktion = -1 Then
						Stimme[1].aufnehmen_starten()
					End If
				ElseIf Maus.x < 976 Then
					DrawImage Sprechblase, 843, 271
					SetColor 0,0,0
					DrawText "Stimmen", 881, 306
					DrawText "vertauschen", 870, 324
					SetColor 255,255,255
					If Maus.Aktion > 0 Then
						DrawImage MenuSchalter, 927, 246, 9
					ElseIf Maus.Aktion = -1 Then
						'--------------------------------------------------
						Local ZwischenNotenliste:TList = CreateList()
						Local ZwischenPausenliste:TList = CreateList()
						'--------------------------------------------------
						For Local Note:TNote = EachIn Stimme[0].Notenliste
							ListAddLast(ZwischenNotenliste, Note)
						Next
						For Local Pause:TPause = EachIn Stimme[0].Pausenliste
							ListAddLast(ZwischenPausenliste, Pause)
						Next
						'--------------------------------------------------
						ClearList(Stimme[0].Notenliste)
						ClearList(Stimme[0].Pausenliste)		
						For Local Note:TNote = EachIn Stimme[1].Notenliste
							Note.y = Note.y - 80
							ListAddLast(Stimme[0].Notenliste, Note)
						Next
						For Local Pause:TPause = EachIn Stimme[1].Pausenliste
							Pause.y = Pause.y - 80
							ListAddLast(Stimme[0].Pausenliste, Pause)
						Next
						'--------------------------------------------------	
						ClearList(Stimme[1].Notenliste)
						ClearList(Stimme[1].Pausenliste)		
						For Local Note:TNote = EachIn ZwischenNotenliste
							Note.y = Note.y + 80
							ListAddLast(Stimme[1].Notenliste, Note)
						Next
						For Local Pause:TPause = EachIn ZwischenPausenliste
							Pause.y = Pause.y + 80
							ListAddLast(Stimme[1].Pausenliste, Pause)
						Next
						'--------------------------------------------------
					End If
				End If
			End If
		End If
	End If
End Function

'_______________________________________________________________________

Function Optionen_verwenden()
	'---------------------------
	If Maus.x < 248 Then
		If Maus.x > 145 Then
			If Maus.y > 256 Then
				If Maus.y < 288 Then
					DrawImage Optionenschalter, 146, 257
					If Maus.Aktion = 1 Or Maus.Radbewegung > 0 Then
						If CountList(Stimme[0].Notenliste) > 0 Or CountList(Stimme[1].Notenliste) > 0 Then
							Notify("Der Taktwechsel wirkt sich nur auf neu aufgenommene Noten aus!~nWenn du den Takt ndern willst, klicke vorher auf ''Neu''~nund entferne damit alle vorhandenen Noten.")
							FlushMouse()
							FlushKeys()
							Maus.Aktion = -1
						Else
							Viertel_pro_Takt = ((Viertel_pro_Takt -3) + 1) Mod 3 + 3
							MaximalNotenwert = Min(Viertel_pro_Takt, 4) * Quantisierung[4]
							MaximalDauer = Quantisierung[3] * 4 * Viertel_pro_Takt * MaximalTaktAnzahl
							TNote.Sechzehntel_x_Position_berechnen(70, 974)
						End If
					ElseIf Maus.Radbewegung < 0 Then
						If CountList(Stimme[0].Notenliste) > 0 Or CountList(Stimme[1].Notenliste) > 0 Then
							Notify("Der Taktwechsel wirkt sich nur auf neu aufgenommene Noten aus!~nWenn du den Takt ndern willst, klicke vorher auf ''Neu''~nund entferne damit alle vorhandenen Noten.")
							FlushMouse()
							FlushKeys()
							Maus.Aktion = -1
						Else
							Viertel_pro_Takt = Viertel_pro_Takt - 1
							If Viertel_pro_Takt < 3 Then Viertel_pro_Takt = 5
							MaximalNotenwert = Min(Viertel_pro_Takt, 4) * Quantisierung[4]
							MaximalDauer = Quantisierung[3] * 4 * Viertel_pro_Takt * MaximalTaktAnzahl
							TNote.Sechzehntel_x_Position_berechnen(70, 974)
						End If
					End If
				ElseIf Maus.y < 321 Then
					DrawImage Optionenschalter, 146, 290
					If Maus.Aktion = 1 Or Maus.Radbewegung > 0 Then
						Schlaege_pro_Minute = Schlaege_pro_Minute + 10
						If Schlaege_pro_Minute > 120 Then Schlaege_pro_Minute = 30
						Quantisierungsdaten_anpassen()
						Stimme[0].Noten_an_neues_Tempo_anpassen()
						Stimme[1].Noten_an_neues_Tempo_anpassen()
						Quantisierung[5] = Quantisierung[3]
					ElseIf Maus.Radbewegung < 0 Then
						Schlaege_pro_Minute = Schlaege_pro_Minute - 10
						If Schlaege_pro_Minute < 30 Then Schlaege_pro_Minute = 120
						Quantisierungsdaten_anpassen()
						Stimme[0].Noten_an_neues_Tempo_anpassen()
						Stimme[1].Noten_an_neues_Tempo_anpassen()
						Quantisierung[5] = Quantisierung[3]
					End If
				ElseIf Maus.y < 354 Then
					DrawImage Optionenschalter, 146, 323
					If Maus.Aktion = 1 Or Maus.Radbewegung > 0 Then
						If Quantisierung[0] = 4 Then
							Quantisierung[0] = 8
						ElseIf Quantisierung[0] = 8 Then
							Quantisierung[0] = 16
						Else
							Quantisierung[0] = 4
						End If
						Quantisierungsdaten_anpassen()
						Quantisierung[5] = Quantisierung[3]		'Memo-Sechzehntel (fuer Tempowechsel notwendig)
						Stimme[0].Alle_Noten_neu_quantisieren()
						Stimme[1].Alle_Noten_neu_quantisieren()
					ElseIf Maus.Radbewegung < 0 Then
						If Quantisierung[0] = 4 Then
							Quantisierung[0] = 16
						ElseIf Quantisierung[0] = 8 Then
							Quantisierung[0] = 4
						Else
							Quantisierung[0] = 8
						End If
						Quantisierungsdaten_anpassen()
						Quantisierung[5] = Quantisierung[3]		'Memo-Sechzehntel (fuer Tempowechsel notwendig)
						Stimme[0].Alle_Noten_neu_quantisieren()
						Stimme[1].Alle_Noten_neu_quantisieren()
					End If
				ElseIf Maus.y < 387 Then
					DrawImage Optionenschalter, 146, 356
					If Maus.Aktion = 1 Or Maus.Radbewegung > 0 Then
						EnharmonikIndex = (EnharmonikIndex + 1) Mod 26
						Noten_Namen_definieren()
						Stimme[0].Alle_Noten_enharmonisch_umdeuten()
						Stimme[1].Alle_Noten_enharmonisch_umdeuten()
					ElseIf Maus.Radbewegung < 0 Then
						EnharmonikIndex = EnharmonikIndex - 1
						If EnharmonikIndex < 0 Then EnharmonikIndex = 25
						Noten_Namen_definieren()
						Stimme[0].Alle_Noten_enharmonisch_umdeuten()
						Stimme[1].Alle_Noten_enharmonisch_umdeuten()
					End If
				ElseIf Maus.y < 420 Then
					DrawImage Optionenschalter, 146, 389
					If Maus.Aktion = 1 Or Maus.Radbewegung > 0 Then
						Stimme[0].Instrument = (Stimme[0].Instrument + 1) Mod 11
					ElseIf Maus.Radbewegung < 0 Then
						Stimme[0].Instrument = Stimme[0].Instrument - 1
						If Stimme[0].Instrument < 0 Then Stimme[0].Instrument = 10
					End If
				ElseIf Maus.y < 453 Then
					DrawImage Optionenschalter, 146, 422
					If Maus.Aktion = 1 Or Maus.Radbewegung > 0 Then
						Stimme[1].Instrument = (Stimme[1].Instrument + 1) Mod 11
					ElseIf Maus.Radbewegung < 0 Then
						Stimme[1].Instrument = Stimme[1].Instrument - 1
						If Stimme[1].Instrument < 0 Then Stimme[1].Instrument = 10
					End If
				ElseIf Maus.y < 486 Then
					DrawImage Optionenschalter, 146, 455
					If Maus.Aktion = 1 Or Maus.Radbewegung > 0 Then
						Klangvolumen = Klangvolumen + 5
						If Klangvolumen > 100 Then Klangvolumen = 0
					ElseIf Maus.Radbewegung < 0 Then
						Klangvolumen = Klangvolumen - 5
						If Klangvolumen < 0 Then Klangvolumen = 100
					End If
				End If
			End If
		End If
	End If
	'---------------------------
	SetColor 0,0,0
	DrawText Viertel_pro_Takt + "/4", 185, 262
	DrawText Schlaege_pro_Minute, 187, 295
	DrawText  "1/" + Quantisierung[0], 185, 328
	DrawText Enharmonik[EnharmonikIndex], 196 - TextWidth(Enharmonik[EnharmonikIndex])/2, 361
	DrawText Instrumentenname[Stimme[0].Instrument], 196 - TextWidth(Instrumentenname[Stimme[0].Instrument])/2, 394
	DrawText Instrumentenname[Stimme[1].Instrument], 196 - TextWidth(Instrumentenname[Stimme[1].Instrument])/2, 427
	DrawText Klangvolumen + " %", 182, 460
	SetColor 255,255,255
	'---------------------------
End Function

'_______________________________________________________________________